import json
import boto3
import random
import weather
from pyproj import Transformer
from threading import Thread
import geopandas
import slope

dynamodb = boto3.client('dynamodb')

def test(lat,lon):
    return "worked!"

# creates a file, similar to points.json, but with only some random sample of "amount" points
def create_subfile(amount = 5000, name = False):
    if not name:
        name = f"{str(amount)}point.json"
    with open("key_files/points.json") as f:
        all_points = json.load(f)
    some_points = random.sample(all_points, amount)
    with open(f"key_files/{name}", "w") as f:
        json.dump(some_points, f)
# ran: create_subfile(1000)
# ran: create_subfile(1)
#create_subfile(100, "check.json")


def add_attribute_to_point(meters,point_array,index,attribute,function):
    point_str = str(point_array)
    if meters:
        # set lat lon values as the meters values
        lat,lon = point_array
    else:
        # get the point as a string and index into the database to get latlon values
        point_str = json.dumps(point_array)
        point = dynamodb.get_item(
            TableName="points",
            Key={
                'point': {'S': point_str}
            },
            AttributesToGet=["latlon"]
        )
        attributes = point['Item']
        lat,lon = json.loads(attributes['latlon']['S'])
    value = function(lat, lon)
    if value == False:
        return
    value = str(value)
    
    # update the item with key name and value function output
    dynamodb.update_item(
        TableName='points',
        Key={'point':{'S':point_str}},
        UpdateExpression=
            "SET #attr = :val"
        ,
        ExpressionAttributeNames={'#attr': attribute},
        ExpressionAttributeValues={':val': {"S":value}}
    )
    print(index)



# adds an attribute to all the points from a given pointlist file
def add_attribute(attribute, function, points = "points.json", meters = False):
    # load points from file containing some subset of points
    with open(f"key_files/{points}") as f:
        points_list = json.load(f)
    length = len(points_list)
    threads_amount = 1

    # create the threads
    for i in range(length//threads_amount):
        threads = []
        for j in range(threads_amount):
            index = i*threads_amount+j
            t = Thread(target=add_attribute_to_point, args=(meters,points_list[index],index,attribute,function))
            threads.append(t)

        # start the threads
        [ t.start() for t in threads ]
        # wait for the threads to finish
        [ t.join() for t in threads ]

filename = "trail_use/1000traffics.json"

def use_file(lat,lon):
    with open(filename) as f:
        data = json.load(f)
    latlonstr = str([lat,lon])
    print(data[latlonstr])
    return(data[latlonstr])

#add_attribute("test", test, "1000point.json")
#add_attribute("slope", slope.find_slope,"1point.json",True)
add_attribute("traffic", use_file, "1000point.json", True)
#add_attribute("slope",slope.find_slope,"check.json", True)

def check(attribute, type, points = "points.json"):
    with open(f"key_files/{points}") as f:
        points_list = json.load(f)
    for point in points_list:
        # get the point as a string and index into the database to get latlon values
        point_str = json.dumps(point)
        point = dynamodb.get_item(
            TableName="points",
            Key={
                'point': {'S': point_str}
            },
            AttributesToGet=[attribute]
        )
        attributes = point['Item']
        if attribute in attributes:
            value = json.loads(attributes[attribute][type])
        else:
            print(f"Missing {point_str}")

#check("slope", "S", "1000point.json")