import weather
import slope
from trail_use import trailuse2
from pyproj import Transformer
from sklearn.preprocessing import PolynomialFeatures
import pandas as pd
import statistics


import asyncio
import pickle
import joblib
from sklearn.linear_model import LinearRegression

def run_point(lat,lon):
    #get the model
    with open('model.pkl', 'rb') as file:
        model = pickle.load(file)
    weatherval = weather.get_average_rainfall(lat,lon)

    #convert latlon to meters
    transformer = Transformer.from_crs("WGS84", "EPSG:3857")
    lat,lon = transformer.transform(lat,lon)

    slopeval = slope.find_slope(lat,lon)

    trafficval = asyncio.run(trailuse2.scrape_one(lat,lon))

    ind = {"weather":[weatherval], "slope":[slopeval], "traffic":[trafficval]}

    X = pd.DataFrame(ind)

    poly = joblib.load('poly.pkl')
    X_poly = poly.transform(X)

    print(X)
    return model.predict(X_poly)[0]


#print(run_point(34.736950658584384, -118.65397430292698))

trail_points = [[35.671078, -105.900324],[35.672873, -105.900587],[35.672177, -105.897615],[35.672209, -105.895599],[35.671432, -105.894452],[35.670916, -105.891016],[35.671301, -105.887652],[35.672324, -105.883653],[35.673461, -105.882233],[35.672707, -105.879994],[35.671925, -105.878862],[35.67132, -105.877691],[35.671402, -105.876369],[35.669548, -105.876574],[35.66789, -105.875981]]

trail_miles = 2.2
def run_trail(trail_points, trail_miles):
    trail_vals = []
    for point in trail_points:
        trail_vals.append(run_point(point))
    hours_per_mile_per_year = statistics.mean(trail_vals)
    print(hours_per_mile_per_year)
    final_val = hours_per_mile_per_year*trail_miles
    return(final_val)