import json
import boto3
import random
import weather
from pyproj import Transformer
import slope
import geopandas
#import <filename>

dynamodb = boto3.client('dynamodb')
#makes list of points converted to latlon
def create_subfile_latlon(amount = 5000):
    with open("key_files/points.json") as f:
        all_points = json.load(f)
    some_mercator_points = random.sample(all_points, amount)
    transformer = Transformer.from_crs("EPSG:3857", "EPSG:4326")
    some_points = [transformer.transform(point[0],point[1]) for point in some_mercator_points]
    with open(f"latlons/{str(amount)}latlon.json", "w") as f:
        json.dump(some_points, f)
create_subfile_latlon(1000)


# runs a function on all points in a latlons file and prints results
def test(function, points = "100latlon.json"):
    # load points from file containing some subset of points
    with open(f"latlons/{points}") as f:
        points_list = json.load(f)
    length = len(points_list)

    # loop through the list of points
    for n, latlon in enumerate(points_list):
        # get the value using the latlon
        lat, lon = latlon
        value = str(function(lat, lon))

        #print progress
        print(f"{n}/{length}: \n - point: {latlon}\n - value: {value}")

#dont put parenthesis in function name
#test(<filename>.<functionname>, "100latlon.json")
test(weather.get_average_rainfall, "100latlon.json")
#test(slope.find_slope, "1000point.json")
